#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "/home/devel/UnholyKnights-CommonSource/class.h"
#include "/home/devel/UnholyKnights-CommonSource/armor.h"
#include "/home/devel/UnholyKnights-CommonSource/helm.h"
#include "/home/devel/UnholyKnights-CommonSource/spell.h"
#include "/home/devel/UnholyKnights-CommonSource/land.h"
#include "/home/devel/UnholyKnights-CommonSource/files.h"
#include "/home/devel/UnholyKnights-CommonSource/npc.h"
#include "/home/devel/UnholyKnights-CommonSource/warp.h"
#include "/home/devel/UnholyKnights-CommonSource/monster.h"

/* Account */
void processAccountListShort( void );
void processAccountListLong( void );
void processAccountEdit( void );
void processAccount( void );

/* Database */
void processDatabaseListShort( void );
void processDatabaseListLong( void );
void processDatabaseEdit( void );
void processDatabase( void );

/* Class */
void processClassListShort( void );
void processClassListLong( void );
void processClassEdit( void );
void processClassAdd( void );
void processClass( void );

/* Armor */
void processArmorListShort( void );
void processArmorListLong( void );
void processArmorEdit( void );
void processArmorAdd( void );
void processArmor( void );

/* Helm */
void processHelmListShort( void );
void processHelmListLong( void );
void processHelmEdit( void );
void processHelmAdd( void );
void processHelm( void );

/* Npc */
void processNpcListShort( void );
void processNpcListLong( void );
void processNpcEdit( void );
void processNpcAdd( void );
void processNpc( void );

/* Warp */
void processWarpListShort( void );
void processWarpListLong( void );
void processWarpEdit( void );
void processWarpAdd( void );
void processWarp( void );

/* Monster */
void processMonsterListShort( void );
void processMonsterListLong( void );
void processMonsterEdit( void );
void processMonsetAdd( void );
void processMonster( void );

/* Misc */
int lookupData( int, void *, int, char * );
int saveData( int, void *, int, char * );

typedef struct {
	char	name[13];
	char	info[20];
	long	timeOnline;
	long	timesConnect;
	long	created;
	int	class;
	int	str;
	int	def;
	int	mag;
	int	spd;
	int	hp;
	int	curhp;
	int	mp;
	int	curmp;
	int	level;
	long	exp;
	int	left;
	int	right;
	int	armor;
	int	helm;
	int	itemA;
	int	itemB;
	int	boots;
	int	neck;
	int	skillA;
	int	skillB;
	int	skillC;
	int	posLevel;
	int	posX;
	int	posY;
	int	sysop;
	int	inventory[3][26];
	int	spells[26];
} accountDatabase;

typedef struct {
	char	id[20];
	char	pass[20];
	long	created;
	int	idS[5];
} accountInformation;
